<?php

#################################################################################
#    PHP-RESIDENCE
#    Copyright (C) 2001-2004 by Marco Maria Francesco De Santis (marcods@gmx.net)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#################################################################################




# Function per passare dalla tabella prenota alle variabili
function tab_a_var ($limiti_var,$app_prenota_id,$app_orig_prenota_id,$inizio_prenota_id,$fine_prenota_id,$app_assegnabili_id,$prenota_in_settimana_id,$anno,$dati_app,$profondita,$nome_tab_prenota = "prenota") {
global $PHPR_TAB_PRE;
$tableprenota = $nome_tab_prenota . $anno . $profondita[iniziale];
$tableperiodi = $PHPR_TAB_PRE."periodi".$anno;
$tableappartamenti = $PHPR_TAB_PRE."appartamenti";

#calcolo l'id del periodo corrente per le prenotazioni gi iniziate ==> fisse
if (!$limiti_var[idperiodocorrente]) {
$oggi = date("Y-m-d");
$annocorrente = date("Y");
$idperiodocorrente = esegui_query("select idperiodi from $tableperiodi where datainizio <= '$oggi' and datafine >= '$oggi' ");
$numidperiodocorrente = numlin_query($idperiodocorrente);
if ($numidperiodocorrente >= 1) {
$num_risposta = 0;
if ($numidperiodocorrente == 2) $num_risposta = 1;
$idperiodocorrente = risul_query($idperiodocorrente,$num_risposta,idperiodi);
} # fine if ($numidperiodocorrente >= 1)
else {
if ( $anno < $annocorrente ) $idperiodocorrente = 100000;
if ( $anno >= $annocorrente ) $idperiodocorrente = -1;
} # fine else if ($numidperiodocorrente >= 1)
$limiti_var[idperiodocorrente] = $idperiodocorrente;
} # fine if (!$limiti_var[idperiodocorrente])

# metto i dati della tabella appartamenti in $dati_app
if (!$dati_app) {
$idapp = esegui_query("select idappartamenti,maxoccupanti from $tableappartamenti order by priorita");
$numappartamenti = numlin_query($idapp);
for ($num1 = 0 ; $num1 < $numappartamenti ; $num1++) {
$numapp = risul_query($idapp,$num1,idappartamenti);
$maxocc = risul_query($idapp,$num1,maxoccupanti);
$dati_app[posizione][$num1] = $numapp;
$dati_app[maxocc][$numapp] = $maxocc;
} # fine for $num1
asort ($dati_app[maxocc]);
reset ($dati_app[maxocc]);
$dati_app[minocc] = current($dati_app[maxocc]);
$lista_tutti_app = ",";
while (list ($key, $val) = each ($dati_app[posizione])) {
$lista_tutti_app .= "$val,";
} # fine while
$dati_app[lista] = $lista_tutti_app;
$dati_app[totapp] = $numappartamenti;
} # fine if (!$dati_app)

if (!$limiti_var[ini]) $limiti_var[ini] = $limiti_var[n_fine];
if (!$limiti_var[fine]) $limiti_var[fine] = $limiti_var[n_ini];
$prenota_in_var = esegui_query("select idprenota,idappartamenti,iddatainizio,iddatafine,assegnazioneapp,app_assegnabili,num_persone from $tableprenota where (iddatainizio <= '".$limiti_var[ini]."' and iddatafine >= '".$limiti_var[n_ini]."') or (iddatainizio <= '".$limiti_var[n_fine]."' and iddatafine >= '".$limiti_var[fine]."')");
$num_prenota_in_var = numlin_query($prenota_in_var);
for ($num1 = 0 ; $num1 < $num_prenota_in_var ; $num1++) {
$idprenota = risul_query($prenota_in_var,$num1,idprenota);
if (!$app_prenota_id[$idprenota]) {
$app_prenota_id[$idprenota] = risul_query($prenota_in_var,$num1,idappartamenti);
$app_orig_prenota_id[$idprenota] = $app_prenota_id[$idprenota];
$inizio_prenota_id[$idprenota] = risul_query($prenota_in_var,$num1,iddatainizio);
$fine_prenota_id[$idprenota] = risul_query($prenota_in_var,$num1,iddatafine);
for ($num2 = $inizio_prenota_id[$idprenota] ; $num2 <= $fine_prenota_id[$idprenota] ; $num2++) {
if (!$prenota_in_settimana_id[$num2]) $prenota_in_settimana_id[$num2] = ",";
$prenota_in_settimana_id[$num2] .= "$idprenota,";
} # fine for $num2
$assegnazione_app = risul_query($prenota_in_var,$num1,assegnazioneapp);
if ($inizio_prenota_id[$idprenota] > $limiti_var[idperiodocorrente] and $assegnazione_app != "k") {
$num_persone = risul_query($prenota_in_var,$num1,num_persone);
$app_assegnabili = risul_query($prenota_in_var,$num1,app_assegnabili);
if (!$num_persone or $num_persone <= $dati_app[minocc]) {
if ($assegnazione_app == "v") $app_assegnabili_id[$idprenota] = "v";
if ($assegnazione_app == "c") $app_assegnabili_id[$idprenota] = $app_assegnabili;
} # fine if (!$num_persone or $num_persone <= $dati_app[minocc])
else {
if ($assegnazione_app == "v") $lista_app = $dati_app[lista];
if ($assegnazione_app == "c") $lista_app = ",".$app_assegnabili.",";
$app_in_lista = explode (",", $lista_app);
$num_app_in_lista = count($app_in_lista) - 1;
for ($num2 = 1 ; $num2 < $num_app_in_lista ; $num2++) {
if ($dati_app[maxocc][$app_in_lista[$num2]] < $num_persone) {
$lista_app = str_replace(",".$app_in_lista[$num2].",",",",$lista_app);
} # fine if ($dati_app[maxocc][$app_in_lista[$num2]] < $num_persone)
} # fine for $num2
$lista_app = substr($lista_app,1,-1);
$app_assegnabili_id[$idprenota] = $lista_app;
} # fine else if (!$num_persone or $num_persone <= $dati_app[minocc])
} # fine if ($inizio_prenota_id[$idprenota] > $limiti_var[idperiodocorrente] and $assegnazione_app != "k")
} # fine if (!$app_prenota_id[$idprenota])
} # fine for $num1
if ($limiti_var[n_ini] < $limiti_var[ini]) $limiti_var[ini] = $limiti_var[n_ini];
if ($limiti_var[n_fine] > $limiti_var[fine]) $limiti_var[fine] = $limiti_var[n_fine];

} # fine function tab_a_var





# Function per trovare tutte le prenotazioni in un appartamento in un certo periodo
function prenota_in_app_e_periodo ($app,$ini_periodo,$fine_periodo,$app_prenota_id,$prenota_in_settimana_id) {
for ($num1 = $ini_periodo ; $num1 <= $fine_periodo ; $num1++) $lista_prenota_periodo .= substr($prenota_in_settimana_id[$num1],1);
$lista_prenota_periodo = substr($lista_prenota_periodo,0,-1);
if ($lista_prenota_periodo) $lista_prenota_periodo = explode(",",$lista_prenota_periodo);
else unset($lista_prenota_periodo);
for ($num1 = 0 ; $num1 < count($lista_prenota_periodo) ; $num1++) {
if ($app_prenota_id[$lista_prenota_periodo[$num1]] == $app) $prenota_presente[$lista_prenota_periodo[$num1]] = 1;
} # fine for $num1
return $prenota_presente;
} # fine function prenota_in_app_e_periodo





# function che controlla che gli app. richiesti non siano tutti occupati
function controlla_tutti_occupati ($idinizio,$idfine,$app_richiesti,$prenota_in_settimana_id,$app_prenota_id,$app_assegnabili_id,$dati_app) {
$tutti_occupati = "NO";
if ($app_richiesti) while (list($key, $val) = each($app_richiesti)) if ($val != "SI") unset($app_richiesti[$key]);
if (!$app_richiesti) $num_app_controlla_orig = $dati_app[totapp];
else $num_app_controlla_orig = count($app_richiesti);
for ($num1 = $idinizio ; $num1 <= $idfine ; $num1++) {
$num_prenota_presenti_in_settimana = count(explode(",",$prenota_in_settimana_id[$num1])) - 2;
if ($num_prenota_presenti_in_settimana >= $num_app_controlla_orig) {
if (!$app_richiesti) { $tutti_occupati = "SI"; break; }
else {
$app_controlla = $app_richiesti;
$uno_libero = "NO";
reset($app_controlla);
while (list($key, $val) = each($app_controlla)) {
$prenotainperiodo = prenota_in_app_e_periodo($key,$num1,$num1,&$app_prenota_id,&$prenota_in_settimana_id);
if (count($prenotainperiodo) == 0) { $uno_libero = "SI"; break; }
$app_assegnabili_prenota = $app_assegnabili_id[key($prenotainperiodo)];
if ($app_assegnabili_prenota == "v") {
if ($num_prenota_presenti_in_settimana < $dati_app[totapp]) $uno_libero = "SI";
break;
} # fine if ($app_assegnabili_prenota == "v")
if ($app_assegnabili_prenota) {
$app_assegnabili_prenota = explode (",", $app_assegnabili_prenota);
for ($num2 = 0 ; $num2 < count($app_assegnabili_prenota) ; $num2++) if (!$app_controlla[$app_assegnabili_prenota[$num2]]) $app_controlla[$app_assegnabili_prenota[$num2]] = "SI";
} # fine if ($app_assegnabili_prenota)
} # fine while (list($key, $val) = each($app_controlla))
if ($uno_libero == "NO") { $tutti_occupati = "SI"; break; }
} # fine else if (!$app_richiesti)
} # fine if ($num_prenota_presenti_in_settimana >= $num_app_controlla_orig)
} # fine for $num1
return $tutti_occupati;
} # fine function controlla_tutti_occupati




# Struttura delle variabili sulle prenotazioni create con tab_a_var() :
#
# $prenota_in_settimana_id[id_settimana] = ",id_prenota,id_prenota,...,id_prenota,"
# $inizio_prenota_id[id_prenota] = "id_settimana"
# $fine_prenota_id[id_prenota] = "id_settimana"
# $app_prenota_id[id_prenota] = "id_app"
# $app_assegnabili_id[id_prenota] = {"id_app,id_app,...,id_app" | "v" | ""} (app. fisso se vuoto)





#
# LIBERASETTIMANE: function ricorsiva per l'assegnazione dell'appartamento.
#
function liberasettimane ($idinizio,$idfine,$limiti_var,$anno,$fatto,$appartamento,$profondita,$app_richiesti,$app_prenota_id,$app_orig_prenota_id,$inizio_prenota_id,$fine_prenota_id,$app_assegnabili_id,$prenota_in_settimana_id,$dati_app,$nome_tab_prenota = "prenota") {
$limiti_var[n_ini] = $idinizio;
$limiti_var[n_fine] = $idfine;
if (!is_array($profondita)) {
$primo_ciclo = "SI";
$prof_copia = $profondita;
$profondita = "";
$profondita[iniziale] = $prof_copia;
$profondita[attuale] = $prof_copia;
$tableprenota = $nome_tab_prenota . $anno . $profondita[iniziale];
$max_prenota = esegui_query("select max(idprenota) from $tableprenota");
$tot_prenota = risul_query($max_prenota,0,0);
$profondita[tot_prenota_ini] = $tot_prenota;
$profondita[tot_prenota_attuale] = $tot_prenota;
tab_a_var (&$limiti_var,&$app_prenota_id,&$app_orig_prenota_id,&$inizio_prenota_id,&$fine_prenota_id,&$app_assegnabili_id,&$prenota_in_settimana_id,$anno,&$dati_app,$profondita,$nome_tab_prenota);
$tutti_occupati = controlla_tutti_occupati ($idinizio,$idfine,&$app_richiesti,&$prenota_in_settimana_id,&$app_prenota_id,&$app_assegnabili_id,&$dati_app);
} # fine if (!is_array($profondita))
if ($tutti_occupati == "SI") $fatto = "SI";
else $fatto = "NO";
$num_da_liberare = 1;


# cicli da ripetere per ogni appartamento fino a che $fatto = SI

# primo ciclo che controlla se c' gi un appartamento libero
if ($fatto != "SI") {
for ($num1 = 0 ; $num1 < $dati_app[totapp] ; $num1++) {
$numapp = $dati_app[posizione][$num1];
if (!$app_richiesti or $app_richiesti[$numapp] == "SI") {
$prenotainperiodo = prenota_in_app_e_periodo($numapp,$idinizio,$idfine,&$app_prenota_id,&$prenota_in_settimana_id);
if (count($prenotainperiodo) == 0) {
$appartamento = $numapp;
$fatto = "SI";
break;
} # fine if (count($prenotainperiodo) == 0)
} # fine if (!$app_richiesti or $app_richiesti[$numapp] == "SI")
} # fine for $num1
} # fine if ($fatto != "SI")

if ($fatto != "SI") {

# allargo il periodo passato dalla tabella alle variabili se necessario
$lista_prenota_periodo = "";
if (!$limiti_var[s_ini]) {
for ($num1 = $idinizio ; $num1 <= $idfine ; $num1++) $lista_prenota_periodo .= substr($prenota_in_settimana_id[$num1],1);
$limiti_var[s_ini] = $idinizio;
$limiti_var[s_fine] = $idfine;
} # fine if (!$limiti_var[s_ini])
if ($limiti_var[s_ini] > $idinizio) { 
for ($num1 = $idinizio ; $num1 < $limiti_var[s_ini] ; $num1++) $lista_prenota_periodo .= substr($prenota_in_settimana_id[$num1],1);
$limiti_var[s_ini] = $idinizio;
} # fine if ($limiti_var[s_ini] > $idinizio)
if ($limiti_var[s_fine] < $idfine) { 
for ($num1 = $limiti_var[s_fine] + 1 ; $num1 <= $idfine ; $num1++) $lista_prenota_periodo .= substr($prenota_in_settimana_id[$num1],1);
$limiti_var[s_fine] = $idfine;
} # fine if ($limiti_var[s_ini] > $idinizio)
$lista_prenota_periodo = substr($lista_prenota_periodo,0,-1);
if ($lista_prenota_periodo) $lista_prenota_periodo = explode(",",$lista_prenota_periodo);
else unset($lista_prenota_periodo);
for ($num1 = 0 ; $num1 < count($lista_prenota_periodo) ; $num1++) {
if ($inizio_prenota_id[$lista_prenota_periodo[$num1]] < $limiti_var[n_ini]) $limiti_var[n_ini] = $inizio_prenota_id[$lista_prenota_periodo[$num1]];
if ($fine_prenota_id[$lista_prenota_periodo[$num1]] > $limiti_var[n_fine]) $limiti_var[n_fine] = $fine_prenota_id[$lista_prenota_periodo[$num1]];
} # fine for $num1
if ($limiti_var[n_ini] < $limiti_var[ini] or $limiti_var[n_fine] > $limiti_var[fine]) {
tab_a_var (&$limiti_var,&$app_prenota_id,&$app_orig_prenota_id,&$inizio_prenota_id,&$fine_prenota_id,&$app_assegnabili_id,&$prenota_in_settimana_id,$anno,&$dati_app,$profondita,$nome_tab_prenota);
} # fine if ($limiti_var[n_ini] < $limiti_var[ini] or $limiti_var[n_fine] > $limiti_var[fine])

# ciclo che prova a spostare le prime prenotazioni ed eventualmente le
# mette in $da_liberare o $da_scambiare
for ($num1 = 0 ; $num1 < $dati_app[totapp] ; $num1++) {
$numapp = $dati_app[posizione][$num1];
if (!$app_richiesti or $app_richiesti[$numapp] == "SI") {
$prenotainperiodo = prenota_in_app_e_periodo($numapp,$idinizio,$idfine,&$app_prenota_id,&$prenota_in_settimana_id);
$idiniziop = "";
$idfinep = "";
unset($app_assegnabili);
$mobile = "SI";
$numprenotainperiodo = count($prenotainperiodo);

# Trovo le prenotazioni del periodo per l'appartamento $numapp, controllo
# che si posssano muovere e trovo le settimane iniziale e finale, e i 
# vincoli sull'appartamento di destinazione ($num_min_persome, $numcasa e
# $num_piano).
reset($prenotainperiodo);
while (list($key, $val) = each($prenotainperiodo)) {
$idprenotainperiodo = $key;
if ($app_assegnabili_id[$idprenotainperiodo] and $app_assegnabili_id[$idprenotainperiodo] != "v") {
$vett_assegnabili = explode (",", $app_assegnabili_id[$idprenotainperiodo]);
$num_assegnabili = count($vett_assegnabili);
for ($num3 = 0 ; $num3 < $num_assegnabili ; $num3++) {
$app_ = $vett_assegnabili[$num3];
$app_assegnabili[$idprenotainperiodo][$app_] = "SI";
} # fine for $num3
} # fine if ($app_assegnabili_id[$idprenotainperiodo] and $app_assegnabili_id[$idprenotainperiodo] != "v")
if ($app_assegnabili_id[$idprenotainperiodo]) {
if (!$idiniziop or $idiniziop > $inizio_prenota_id[$idprenotainperiodo]) {
$idiniziop = $inizio_prenota_id[$idprenotainperiodo];
} # fine if (!$idiniziop or $idiniziop > $inizio_prenota_id[$idprenotainperiodo])
if (!$idfinep or $idfinep < $fine_prenota_id[$idprenotainperiodo]) {
$idfinep = $fine_prenota_id[$idprenotainperiodo];
} # fine if (!$idfinep or $idfinep < $fine_prenota_id[$idprenotainperiodo])
} # fine if ($app_assegnabili_id[$idprenotainperiodo])
else $mobile = "NO";
} # fine while (list($key, $val) = each($prenotainperiodo))


if ($mobile == "SI") {
# Provo a spostare le prenotazioni dell'appartamento $numapp.
$applica_spostamenti = "";
$applica_spostamenti2 = "";
$non_tutti_liberabili = "";
$mobile2 = "SI";
#$liberabile = "";
#$scambiabile = "";
#$da_scambiare = "";
reset($prenotainperiodo);
while (list($key, $val) = each($prenotainperiodo)) {
$idprenotainperiodo = $key;
for ($num3 = 0 ; $num3 < $dati_app[totapp] ; $num3++) {
if ($num3 != $num1) {
$numapp2 = $dati_app[posizione][$num3];
$prenotainperiodo2 = prenota_in_app_e_periodo($numapp2,$inizio_prenota_id[$idprenotainperiodo],$fine_prenota_id[$idprenotainperiodo],&$app_prenota_id,&$prenota_in_settimana_id);
$numprenotainperiodo2 = count($prenotainperiodo2);
if ($app_assegnabili_id[$idprenotainperiodo] == "v" or $app_assegnabili[$idprenotainperiodo][$numapp2] == "SI") {
if ($numprenotainperiodo2 == 0) {
$nuovo_app[$idprenotainperiodo] = $numapp2;
$liberabile[$idprenotainperiodo] = "SI";
$scambiabile[$idprenotainperiodo] = "NO";
break;
} # fine if ($numprenotainperiodo2 == 0)
else {
# Se non si possono spostare vedere se sono da scambiare
$prenota_fissa_presente = "NO";
reset($prenotainperiodo2);
while (list($key2, $val2) = each($prenotainperiodo2)) {
$idprenotainperiodo2 = $key2;
if (!$app_assegnabili_id[$idprenotainperiodo2]) $prenota_fissa_presente = "SI";
else {
# se $idprenotainperiodo  uguale o minore di $idprenotainperiodo2 e ne contiene gli app. assegnabili  inutile fare lo scambio
if ($inizio_prenota_id[$idprenotainperiodo2] <= $inizio_prenota_id[$idprenotainperiodo] and $fine_prenota_id[$idprenotainperiodo2] >= $fine_prenota_id[$idprenotainperiodo]) {
if ($app_assegnabili_id[$idprenotainperiodo] == "v") $prenota_fissa_presente = "SI";
else {
if ($app_assegnabili_id[$idprenotainperiodo2] != "v") {
$vett_assegnabili = explode (",", $app_assegnabili_id[$idprenotainperiodo2]);
$num_assegnabili = count($vett_assegnabili);
$lista_app_contenuta = "SI";
for ($num4 = 0 ; $num4 < $num_assegnabili ; $num4++) {
if ($app_assegnabili[$idprenotainperiodo][$vett_assegnabili[$num4]] != "SI") { $lista_app_contenuta = "NO"; break; }
} # fine for $num4
if ($lista_app_contenuta == "SI") $prenota_fissa_presente = "SI";
} # fine if ($app_assegnabili_id[$idprenotainperiodo2] != "v")
} # fine else if ($app_assegnabili_id[$idprenotainperiodo] == "v")
} # fine if ($inizio_prenota_id[$idprenotainperiodo2] <= $inizio_prenota_id[$idprenotainperiodo] and...
} # fine else if (!$app_assegnabili_id[$idprenotainperiodo2])
} # fine while (list($key2, $val2) = each($prenotainperiodo2))
if ($prenota_fissa_presente == "NO") {
$scambiabile[$idprenotainperiodo] = "SI";
$da_scambiare[$idprenotainperiodo][$numapp2] = "SI";
} # fine if ($prenota_fissa_presente == "NO")
} # fine else if ($numprenotainperiodo2 == 0)
} # fine if ($app_assegnabili_id[$idprenotainperiodo] == "v" or ...
} # fine if ($num3 != $num1)
} # fine for $num3

if ($liberabile[$idprenotainperiodo] != "SI") $tutti_liberabili = "NO";
if ($liberabile[$idprenotainperiodo] != "SI" and $scambiabile[$idprenotainperiodo] != "SI") $mobile2 = "NO";
} # fine while (list($key, $val) = each($prenotainperiodo))

# Applico gli eventuali spostamenti, altrimenti metto i dati in $da_liberare
if ($tutti_liberabili != "NO") {
reset($prenotainperiodo);
while (list($key, $val) = each($prenotainperiodo)) {
$idprenotainperiodo = $key;
$n_app = $nuovo_app[$idprenotainperiodo];
$app_prenota_id[$idprenotainperiodo] = $n_app;
} # fine while (list($key, $val) = each($prenotainperiodo))
$appartamento = $numapp;
$fatto = "SI";
break;
} # fine if ($tutti_liberabili != "NO")

if ($mobile2 == "SI") {
$idinizio_da_liberare[$num_da_liberare] = $idiniziop;
$idfine_da_liberare[$num_da_liberare] = $idfinep;
$app_da_liberare[$num_da_liberare] = $numapp;
$num_da_liberare = $num_da_liberare + 1;
} # fine if ($mobile2 == "SI")

if ($fatto == "SI") { break; }
} # fine if ($mobile == "SI")
} # fine if (!$app_richiesti or $app_richiesti[$numapp] == "SI")
} # fine for $num1

} # fine if ($fatto != "SI")



# Se non  ancora $fatto chiamo ricorsivamente liberasettimane con i dati
# in $da_liberare e $da_scambiare, operando su una variabile temporanea.
if ($fatto == "NO") {
$nuova_profondita[iniziale] = $profondita[iniziale];
$nuova_profondita[attuale] = $profondita[attuale] + 1;
$nuova_profondita[tot_prenota_ini] = $profondita[tot_prenota_ini];

for ($num1 = 1 ; $num1 < $num_da_liberare ; $num1++) {
$n_app_prenota_id = $app_prenota_id;
$nuova_profondita[tot_prenota_attuale] = $profondita[tot_prenota_attuale];
$idiniziop = $idinizio_da_liberare[$num1];
$idfinep = $idfine_da_liberare[$num1];
$numapp = $app_da_liberare[$num1];
$prenotainperiodo = prenota_in_app_e_periodo($numapp,$idiniziop,$idfinep,&$n_app_prenota_id,&$prenota_in_settimana_id);
$numprenotainperiodo = count($prenotainperiodo);

# Muovo le prenotazioni liberabili
reset($prenotainperiodo);
while (list($key, $val) = each($prenotainperiodo)) {
$idprenotainperiodo = $key;
if ($liberabile[$idprenotainperiodo] == "SI") {
$n_app = $nuovo_app[$idprenotainperiodo];
$n_app_prenota_id[$idprenotainperiodo] = $n_app;
} # fine if ($liberabile[$idpenotainperiodo] == "SI")
} # fine while (list($key, $val) = each($prenotainperiodo))

# Riempio gli spazi vuoti con prenotazioni kostanti.
$idinizio_prenota_falsa = $idinizio;
$prenota_falsa_da_inserire = "NO";
for ($num2 = $idinizio ; $num2 <= ($idfine+1) ; $num2++) {
$prenota_presente = prenota_in_app_e_periodo($numapp,$num2,$num2,&$n_app_prenota_id,&$prenota_in_settimana_id);
$num_prenota_presente = count($prenota_presente);
if ($num_prenota_presente != 0 or $num2 == ($idfine+1)) {
if ($prenota_falsa_da_inserire == "SI") {
$new_num_tot_prenota = $new_num_tot_prenota + 1;
$nuova_profondita[tot_prenota_attuale]++;
$n_app_prenota_id[$nuova_profondita[tot_prenota_attuale]] = $numapp;
$inizio_prenota_id[$nuova_profondita[tot_prenota_attuale]] = $idinizio_prenota_falsa;
$fine_prenota_id[$nuova_profondita[tot_prenota_attuale]] = $idfine_prenota_falsa;
for ($num3 = $idinizio_prenota_falsa ; $num3 <= $idfine_prenota_falsa ; $num3++) {
if (!$prenota_in_settimana_id[$num3]) $prenota_in_settimana_id[$num3] = ",";
$prenota_in_settimana_id[$num3] .= $nuova_profondita[tot_prenota_attuale].",";
} # fine for $num3
} # fine if ($prenota_falsa_da_inserire == "SI")
$prenota_falsa_da_inserire = "NO";
$idinizio_prenota_falsa = $num2 + 1;
} # fine if ($num_prenota_presente != 0 or $num2 == ($idfine+1))
else {
$prenota_falsa_da_inserire = "SI";
$idfine_prenota_falsa = $num2;
} # fine else if ($num_prenota_presente != 0 or $num2 == ($idfine+1))
} # fine for $num2

$fatto3 = "SI";
$limiti_var_orig = $limiti_var;
#chiamo ricorsivamente liberasettimane con gli app. $da_scambiare
reset($prenotainperiodo);
while (list($key, $val) = each($prenotainperiodo)) {
$idprenotainperiodo = $key;
if ($scambiabile[$idprenotainperiodo] == "SI") {
$idinizioprenota2 = $inizio_prenota_id[$idprenotainperiodo];
$idfineprenota2 = $fine_prenota_id[$idprenotainperiodo];
if ($idinizioprenota2 > $idinizio) { $idinizio_rimpicciolito = $idinizioprenota2; }
else { $idinizio_rimpicciolito = $idinizio; }
if ($idfineprenota2 < $idfine) { $idfine_rimpicciolito = $idfineprenota2; }
else { $idfine_rimpicciolito = $idfine; }
$inizio_prenota_id[$idprenotainperiodo] = $idinizio_rimpicciolito;
$fine_prenota_id[$idprenotainperiodo] = $idfine_rimpicciolito;
for ($num3 = $idinizioprenota2 ; $num3 < $idinizio_rimpicciolito ; $num3++) {
$prenota_in_settimana_id[$num3] = str_replace(",$idprenotainperiodo,",",",$prenota_in_settimana_id[$num3]);
if ($prenota_in_settimana_id[$num3] == ",") $prenota_in_settimana_id[$num3] = "";
} # fine for $num3
for ($num3 = ($idfine_rimpicciolito+1) ; $num3 <= $idfineprenota2 ; $num3++) {
$prenota_in_settimana_id[$num3] = str_replace(",$idprenotainperiodo,",",",$prenota_in_settimana_id[$num3]);
if ($prenota_in_settimana_id[$num3] == ",") $prenota_in_settimana_id[$num3] = "";
} # fine for $num3
$app_assegnabili_id2 = $app_assegnabili_id[$idprenotainperiodo];
$app_assegnabili_id[$idprenotainperiodo] = "";
$appartamento2 = "";
$fatto2 = "";
$ap_ric = "";
for ($num3 = 0 ; $num3 < $dati_app[totapp] ; $num3++) {
$numapp2 = $dati_app[posizione][$num3];
if ($da_scambiare[$idprenotainperiodo][$numapp2] == "SI") { $ap_ric[$numapp2] = "SI"; }
} # fine for $num3
liberasettimane ($idinizioprenota2,$idfineprenota2,&$limiti_var,$anno,&$fatto2,&$appartamento2,$nuova_profondita,$ap_ric,&$n_app_prenota_id,&$app_orig_prenota_id,&$inizio_prenota_id,&$fine_prenota_id,&$app_assegnabili_id,&$prenota_in_settimana_id,&$dati_app,$nome_tab_prenota);
$inizio_prenota_id[$idprenotainperiodo] = $idinizioprenota2;
$fine_prenota_id[$idprenotainperiodo] = $idfineprenota2;
for ($num3 = $idinizioprenota2 ; $num3 < $idinizio_rimpicciolito ; $num3++) {
if (!$prenota_in_settimana_id[$num3]) $prenota_in_settimana_id[$num3] = ",";
$prenota_in_settimana_id[$num3] .= $idprenotainperiodo.",";
} # fine for $num3
for ($num3 = ($idfine_rimpicciolito+1) ; $num3 <= $idfineprenota2 ; $num3++) {
if (!$prenota_in_settimana_id[$num3]) $prenota_in_settimana_id[$num3] = ",";
$prenota_in_settimana_id[$num3] .= $idprenotainperiodo.",";
} # fine for $num3
$app_assegnabili_id[$idprenotainperiodo] = $app_assegnabili_id2;
if ($fatto2 == "SI") {
$n_app_prenota_id[$idprenotainperiodo] = $appartamento2;
$nuova_profondita[tot_prenota_attuale]++;
$n_app_prenota_id[$nuova_profondita[tot_prenota_attuale]] = $numapp;
$inizio_prenota_id[$nuova_profondita[tot_prenota_attuale]] = $idinizio_rimpicciolito;
$fine_prenota_id[$nuova_profondita[tot_prenota_attuale]] = $idfine_rimpicciolito;
for ($num3 = $idinizio_rimpicciolito ; $num3 <= $idfine_rimpicciolito ; $num3++) {
if (!$prenota_in_settimana_id[$num3]) $prenota_in_settimana_id[$num3] = ",";
$prenota_in_settimana_id[$num3] .= $nuova_profondita[tot_prenota_attuale].",";
} # fine for $num3
} # fine if ($fatto2 == "SI")
else {
$fatto3 = "NO";
if ($limiti_var[ini] < $limiti_var_orig[ini] or $limiti_var[fine] > $limiti_var_orig[fine]) {
reset($app_orig_prenota_id);
while (list($key2, $val2) = each($app_orig_prenota_id)) {
if (!$app_prenota_id[$key2]) $app_prenota_id[$key2] = $val2;
} # fine while (list($key2, $val2) = each($app_orig_prenota_id))
} # fine if ($limiti_var[ini] < $limiti_var_orig[ini] or...
break;
} # fine else if ($fatto2 == "SI")
} # fine if ($scambiabile[$idprenotainperiodo] == "SI")
} # fine while (list($key, $val) = each($prenotainperiodo))

# cancello le prenotazioni kostanti
for ($num2 = ($profondita[tot_prenota_attuale] + 1) ; $num2 <= $nuova_profondita[tot_prenota_attuale] ; $num2++) {
for ($num3 = $inizio_prenota_id[$num2] ; $num3 <= $fine_prenota_id[$num2] ; $num3++) {
$prenota_in_settimana_id[$num3] = str_replace(",$num2,",",",$prenota_in_settimana_id[$num3]);
if ($prenota_in_settimana_id[$num3] == ",") $prenota_in_settimana_id[$num3] = "";
} # fine for $num3
$n_app_prenota_id[$num2] = "";
$inizio_prenota_id[$num2] = "";
$fine_prenota_id[$num2] = "";
} # fine for $num2

if ($fatto3 == "SI") {
$app_prenota_id = $n_app_prenota_id;
$fatto = "SI";
$appartamento = $numapp;
break;
} # fine if ($fatto3 == "SI")

} # fine for $num1

} # fine if ($fatto == "NO")


if ($tutti_occupati == "SI") $fatto = "NO";

if ($primo_ciclo == "SI" and $fatto == "SI" and is_array($app_orig_prenota_id)) {
reset($app_orig_prenota_id);
while (list($idprenota, $app_prenota) = each($app_orig_prenota_id)) {
if ($app_prenota_id[$idprenota] != $app_prenota) {
$app_cambiato = $app_prenota_id[$idprenota];
esegui_query("update $tableprenota set idappartamenti = '$app_cambiato' where idprenota = $idprenota");
} # fine if ($app_prenota_id[$idprenota] != $app_prenota)
} # fine while (list($key, $val) = each($app_orig_prenota_id))
} # fine if ($primo_ciclo == "SI" and $fatto == "SI" and is_array($app_orig_prenota_id))


} # fine function liberasettimane




?>
